<template>
    <div class="login-box">
        <div class="login-logo">
            <a href="../../index2.html"><b>Admin</b>LTE</a>
        </div>
        <div class="login-box-body">
            <p class="login-box-msg">Sign in to start your session</p>
            <form method="post">
                <div class="form-group has-feedback">
                    <input type="email" class="form-control" placeholder="Email" v-model="login_id">
                    <span class="glyphicon glyphicon-envelope form-control-feedback"></span>
                </div>
                <div class="form-group has-feedback">
                    <input type="password" class="form-control" placeholder="Password" v-model="password">
                    <span class="glyphicon glyphicon-lock form-control-feedback"></span>
                </div>
                <div class="row">
                    <div class="col-xs-8">
                        <div class="checkbox icheck">
                            <label>
                                <input type="checkbox"> Remember Me
                            </label>
                        </div>
                    </div>
                    <div class="col-xs-4">
                        <button @click.prevent="handleLogin()" class="btn btn-primary btn-block btn-flat">Sign In</button>
                    </div>
                </div>
            </form>
            <a href="#">I forgot my password</a><br>
            <a href="register.html" class="text-center">Register a new membership</a>
        </div>
    </div>
</template>
<script>
    import {loginUrl, userUrl, getHeader} from "../../configs/config";
    import {client_id, client_secret} from "../../../env";
    import {mapState} from 'vuex'

    export default {
        data() {
            return {
                login_id: '',
                password: ''
            }
        },
        computed: {
            ...mapState({
                UserStore: state => UserStore
            })
        },
        methods: {
            handleLogin: function () {
                let _this = this
                const postData = {
                    grant_type: 'password',
                    client_id: client_id,
                    client_secret: client_secret,
                    username: this.login_id,
                    password: this.password,
                    scope: ''
                }
                const authUser = {};
                window.axios.post(loginUrl, postData)
                    .then(response => {
                         if (response.status === 200) {
                             authUser.access_token = response.data.access_token
                             authUser.refresh_token = response.data.refresh_token
                             localStorage.setItem('authUser', JSON.stringify(authUser))
                             window.axios.get(userUrl, {headers: getHeader()})
                                 .then(response => {
                                     authUser.email = response.data.email
                                     authUser.name = response.data.name
                                     localStorage.setItem('authUser', JSON.stringify(authUser))
                                     _this.$store.dispatch('setAuthUser', authUser)
                                     _this.$router.push({name: 'Home'})
                                 })
                         }
                    })
            }
        }
    }
</script>